Debian Bug report logs - #122444
emacsen-common: Please symlink to the .el when byte compiling for each emacsen

version graph

Package: emacsen-common; Maintainer for emacsen-common is Rob Browning <rlb@defaultvalue.org>; Source for emacsen-common is src:emacsen-common.

Reported by: "Karl M. Hegbloom" <karlheg@microsharp.com>

Date: Tue, 4 Dec 2001 20:33:07 UTC

Severity: wishlist

Tags: patch

Found in version 1.4.13

Fixed in version emacsen-common/1.4.23

Done: Rob Browning <rlb@defaultvalue.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to Rob Browning <rlb@defaultvalue.org>:
Bug#122444; Package emacsen-common. Full text and rfc822 format available.

Acknowledgement sent to "Karl M. Hegbloom" <karlheg@microsharp.com>:
New Bug report received and forwarded. Copy sent to Rob Browning <rlb@defaultvalue.org>. Full text and rfc822 format available.

Message #5 received at maintonly@bugs.debian.org (full text, mbox):

From: "Karl M. Hegbloom" <karlheg@microsharp.com>
To: Debian Bug Tracking System <maintonly@bugs.debian.org>
Subject: emacsen-common: Please symlink to the .el when byte compiling for each emacsen
Date: Tue, 04 Dec 2001 12:31:46 -0800
Package: emacsen-common
Version: 1.4.13
Severity: wishlist

 I would like to be able to use "M-x find-library" and visit the source
 .el to any library.  Currently, many of them have no corresponding .el
 since it's byte compiled and moved.  I would like the .el to be symlinked
 to so it's findable.  Please add that to policy and implement it in the
 scripts.

-- System Information
Debian Release: testing/unstable
Architecture: i386
Kernel: Linux juniper 2.4.14-juniper-ipsec #1 SMP Wed Nov 14 16:38:53 PST 2001 i686
Locale: LANG=C, LC_CTYPE=C

Versions of packages emacsen-common depends on:
ii  bsdmainutils                5.20010615-2 More utilities from FreeBSD.




Information forwarded to debian-bugs-dist@lists.debian.org, Rob Browning <rlb@defaultvalue.org>:
Bug#122444; Package emacsen-common. Full text and rfc822 format available.

Acknowledgement sent to Michael Olson <mwolson@member.fsf.org>:
Extra info received and forwarded to list. Copy sent to Rob Browning <rlb@defaultvalue.org>. Full text and rfc822 format available.

Message #10 received at 122444@bugs.debian.org (full text, mbox):

From: Michael Olson <mwolson@member.fsf.org>
To: 122444@bugs.debian.org, 157123@bugs.debian.org
Subject: Patch to supplement debian policy for load-path and symlinks
Date: Mon, 20 Nov 2006 23:01:06 -0500
[Message part 1 (text/plain, inline)]
I've attached a patch to debian-emacs-policy that helps to fix this
bug.  I mentioned this on the debian-emacsen list, and no one had
anything to say about it after a couple of weeks, so it seems to be
non-controversial.

[Message part 2 (application/pgp-signature, inline)]
[debian-emacs-policy.diff (text/x-patch, inline)]
--- debian-emacs-policy	2006-11-20 22:45:46.000000000 -0500
+++ debian-emacs-policy	2006-11-20 22:52:09.000000000 -0500
@@ -236,6 +236,17 @@
      file.  emacsen-common will make sure that the install/remove
      scripts are ordered to respect inter-add-on package dependencies.
 
+  E) If an Emacs add-on package compiles any of its Emacs Lisp
+     sources, it should install the compiled bytecode files to
+     /usr/share/<flavour>/site-lisp/<package-name>.  It should also
+     create a symlink for each Emacs Lisp source file in
+     /usr/share/<emacs>/site-lisp/<package-name> and store the symlink
+     in /usr/share/<flavour>/site-lisp/<package-name>.  If any
+     byte-compiled Emacs Lisp code is stored in a subdirectory,
+     similar treatment should be used.  This ensures that Emacs will
+     be able to locate the source code for the add-on package when
+     using M-x find-function and similar functionality.
+
 7) Mandatory binary symlink
 
    Each emacsen main package must have a symlink
@@ -277,6 +288,14 @@
    (fboundp 'debian-pkg-add-load-path-item) before calling this
    function, or add a dependency on emacsen-common (>= 1.4.14).
 
+   If an Emacs add-on package compiles its Emacs Lisp sources, it
+   should only add /usr/share/<flavour>/site-lisp/<package-name> (and
+   its subdirectories of compiled code, if applicable) to the load
+   path, rather than /usr/share/<emacs>/site-lisp/<package-name>.  If
+   a subdirectory of /usr/share/<emacs>/site-lisp/<package-name>
+   contains uncompiled Emacs Lisp code, it may also be added to the
+   load path.
+
 10) Usage of autoload instead of load in the site-start.d files.
 
    It's been suggested, and is probably a good idea that maintainers
[Message part 4 (text/plain, inline)]

-- 
Michael Olson -- FSF Associate Member #652 -- http://www.mwolson.org/
Interests: Emacs Lisp, text markup, protocols -- Jabber: mwolson_at_hcoop.net
  /` |\ | | | Projects: Emacs, Muse, ERC, EMMS, Planner, ErBot, DVC
 |_] | \| |_| Reclaim your digital rights by eliminating DRM.
      See http://www.defectivebydesign.org/what_is_drm for details.

Tags added: patch Request was from Michael Olson <mwolson@member.fsf.org> to control@bugs.debian.org. Full text and rfc822 format available.

Tags added: pending Request was from Agustin Martin <agmartin@debian.org> to control@bugs.debian.org. (Tue, 16 Dec 2008 12:30:04 GMT) Full text and rfc822 format available.

Information stored :
Bug#122444; Package emacsen-common. (Tue, 16 Dec 2008 12:30:15 GMT) Full text and rfc822 format available.

Acknowledgement sent to Agustin Martin <agmartin@debian.org>:
Extra info received and filed, but not forwarded. (Tue, 16 Dec 2008 12:30:15 GMT) Full text and rfc822 format available.

Message #19 received at 122444-quiet@bugs.debian.org (full text, mbox):

From: Agustin Martin <agmartin@debian.org>
To: 117564@bugs.debian.org
Cc: 122444-quiet@bugs.debian.org, 124221-quiet@bugs.debian.org, 132355-quiet@bugs.debian.org, 136779-quiet@bugs.debian.org, 157123-quiet@bugs.debian.org, 193575-quiet@bugs.debian.org, 208414-quiet@bugs.debian.org, 222518-quiet@bugs.debian.org, 278008-quiet@bugs.debian.org, 329030-quiet@bugs.debian.org, 361200-quiet@bugs.debian.org, 381516-quiet@bugs.debian.org, 387021-quiet@bugs.debian.org, 424940-quiet@bugs.debian.org, 491129-quiet@bugs.debian.org, 503483-quiet@bugs.debian.org, 269155-quiet@bugs.debian.org
Subject: Tagging bugs affected by my emacsen-common NMU
Date: Tue, 16 Dec 2008 13:28:35 +0100
package emacsen-common
tag 117564 +pending +patch
tag 122444 +pending +patch
tag 124221 +pending +patch
tag 132355 +pending +patch
tag 136779 +pending +patch
tag 157123 +pending +patch
tag 193575 +pending +patch
tag 208414 +pending +patch
tag 222518 +pending +patch
tag 269155 +pending +patch
tag 278008 +pending +patch
tag 329030 +pending +patch
tag 361200 +pending +patch
tag 381516 +pending +patch
tag 387021 +pending +patch
tag 424940 +pending +patch
tag 491129 +pending +patch
tag 503483 +pending +patch
thanks

I am tagging all these bugreports +pending +patch, since they will be dealt
with by the NMU I am preparing. I am currently waiting for news on the lenny
release before actually upload, but since is taking longer than expected I
will probably upload really soon.

Changes go much further than an usual NMU, but since I received no reply on
this during some long time I will proceed with it. Changes can be tracked at
the git repo

git://git.debian.org/git/users/agmartin/my-emacsen-common.git

(browseable through
http://git.debian.org/?p=users/agmartin/my-emacsen-common.git;a=summary)

NMU candidate is available at

http://people.debian.org/~agmartin/debian-store/misc/

-- 
Agustin




Tags added: patch Request was from Agustin Martin <agmartin@debian.org> to control@bugs.debian.org. (Tue, 16 Dec 2008 12:39:05 GMT) Full text and rfc822 format available.

Removed tag(s) pending. Request was from Sven Joachim <svenjoac@gmx.de> to control@bugs.debian.org. (Fri, 28 May 2010 09:06:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Rob Browning <rlb@defaultvalue.org>:
Bug#122444; Package emacsen-common. (Tue, 31 Aug 2010 14:45:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Timo Juhani Lindfors <timo.lindfors@iki.fi>:
Extra info received and forwarded to list. Copy sent to Rob Browning <rlb@defaultvalue.org>. (Tue, 31 Aug 2010 14:45:07 GMT) Full text and rfc822 format available.

Message #28 received at 122444@bugs.debian.org (full text, mbox):

From: Timo Juhani Lindfors <timo.lindfors@iki.fi>
To: 122444@bugs.debian.org
Cc: Agustin Martin <agmartin@debian.org>, Teemu Hukkanen <tjhukkan@iki.fi>
Subject: emacsen policy: patches to update examples, add lintian/piuparts tests
Date: Tue, 31 Aug 2010 17:42:41 +0300
[Message part 1 (text/plain, inline)]
Hi,

I hit some packages (magit, cmake and also others) that seem to
violate this proposed new version of the emacsen policy. One of the
irritating side effects of these violations is that C-h f does not
find source code. From

http://iki.fi/lindi/git/my-emacsen-common.git/

you can pull "symlink-examples" branch that updates the examples to
conform with the new policy chapter 6E and from

http://iki.fi/lindi/git/lintian.git/

you can pull "emacsen" branch that adds a lintian test for emacsen
policy chapter 5. Also, attached is a patch to piuparts with an
additional test to chapter 6E.

Once these are in place, I think we should also update the dh-make
template to use the examples from the policy and start reporting bugs
and patches against emacs add ons that violate the policy.

Is this the right way to proceed?

-Timo
[piuparts_emacsen_symlinks1.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#122444; Package emacsen-common. (Sat, 11 Feb 2012 21:30:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Rob Browning <rlb@defaultvalue.org>:
Extra info received and forwarded to list. (Sat, 11 Feb 2012 21:30:03 GMT) Full text and rfc822 format available.

Message #33 received at 122444@bugs.debian.org (full text, mbox):

From: Rob Browning <rlb@defaultvalue.org>
To: 122444@bugs.debian.org
Cc: Michael Olson <mwolson@member.fsf.org>, Timo Juhani Lindfors <timo.lindfors@iki.fi>, debian-emacsen@lists.debian.org
Subject: emacsen-common: Please symlink to the .el when byte compiling for each emacsen
Date: Sat, 11 Feb 2012 15:19:38 -0600
Michael Olson <mwolson@member.fsf.org> writes:

> I've attached a patch to debian-emacs-policy that helps to fix this
> bug.  I mentioned this on the debian-emacsen list, and no one had
> anything to say about it after a couple of weeks, so it seems to be
> non-controversial.

> --- debian-emacs-policy	2006-11-20 22:45:46.000000000 -0500
> +++ debian-emacs-policy	2006-11-20 22:52:09.000000000 -0500
> @@ -236,6 +236,17 @@
>       file.  emacsen-common will make sure that the install/remove
>       scripts are ordered to respect inter-add-on package dependencies.
>
> +  E) If an Emacs add-on package compiles any of its Emacs Lisp
> +     sources, it should install the compiled bytecode files to
> +     /usr/share/<flavour>/site-lisp/<package-name>.

 [...]

I've finally added something to this effect for an upcoming release
(probably a 1.4.23 release unless I get the major 2.0.0 overhaul out
fairly quickly -- that's more or less working now):

 E) If an add-on package compiles any of its Emacs Lisp sources (which
    must be compiled to a subdirectory of
    /usr/share/<flavor>/site-lisp/<package-name> -- see section 4
    above) it must also create a symlink in the same directory as the
    compiled output that points to the corresponding source file.

    For example, if add-on package foo produces
    /usr/share/emacs23/site-lisp/foo/bar.elc, then it must also create
    a symlink /usr/share/emacs23/site-lisp/foo/bar.el pointing to
    the corresponding source file.  This ensures that Emacs will be
    able to locate the source code for the add-on package when using
    M-x find-function, etc.

> @@ -277,6 +288,14 @@
>     (fboundp 'debian-pkg-add-load-path-item) before calling this
>     function, or add a dependency on emacsen-common (>= 1.4.14).
>
> +   If an Emacs add-on package compiles its Emacs Lisp sources, it
> +   should only add /usr/share/<flavour>/site-lisp/<package-name> (and
> +   its subdirectories of compiled code, if applicable) to the load
> +   path, rather than /usr/share/<emacs>/site-lisp/<package-name>.  If
> +   a subdirectory of /usr/share/<emacs>/site-lisp/<package-name>
> +   contains uncompiled Emacs Lisp code, it may also be added to the
> +   load path.
> +
>  10) Usage of autoload instead of load in the site-start.d files.
>
>     It's been suggested, and is probably a good idea that maintainers

I haven't added this yet because I think existing policy requirements
should already have the intended effect.  Unless I'm forgetting
something, add-on packages are already required to stick to the <flavor>
directories, and the <flavor> directories are required to come first in
the load path for each emacsen (which is enforced for add-ons via
debian-pkg-add-load-path-item -- see section 9).

But please let me know if I've overlooked something.

Thanks
-- 
Rob Browning
rlb @defaultvalue.org and @debian.org
GPG as of 2002-11-03 14DD 432F AE39 534D B592 F9A0 25C8 D377 8C7E 73A4




Reply sent to Rob Browning <rlb@defaultvalue.org>:
You have taken responsibility. (Sat, 11 Feb 2012 22:21:02 GMT) Full text and rfc822 format available.

Notification sent to "Karl M. Hegbloom" <karlheg@microsharp.com>:
Bug acknowledged by developer. (Sat, 11 Feb 2012 22:21:03 GMT) Full text and rfc822 format available.

Message #38 received at 122444-close@bugs.debian.org (full text, mbox):

From: Rob Browning <rlb@defaultvalue.org>
To: 122444-close@bugs.debian.org
Subject: Bug#122444: fixed in emacsen-common 1.4.23
Date: Sat, 11 Feb 2012 22:17:23 +0000
Source: emacsen-common
Source-Version: 1.4.23

We believe that the bug you reported is fixed in the latest version of
emacsen-common, which is due to be installed in the Debian FTP archive:

emacsen-common_1.4.23.dsc
  to main/e/emacsen-common/emacsen-common_1.4.23.dsc
emacsen-common_1.4.23.tar.gz
  to main/e/emacsen-common/emacsen-common_1.4.23.tar.gz
emacsen-common_1.4.23_all.deb
  to main/e/emacsen-common/emacsen-common_1.4.23_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 122444@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Rob Browning <rlb@defaultvalue.org> (supplier of updated emacsen-common package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sat, 11 Feb 2012 15:55:07 -0600
Source: emacsen-common
Binary: emacsen-common
Architecture: source all
Version: 1.4.23
Distribution: unstable
Urgency: low
Maintainer: Rob Browning <rlb@defaultvalue.org>
Changed-By: Rob Browning <rlb@defaultvalue.org>
Description: 
 emacsen-common - Common facilities for all emacsen
Closes: 122444 480894
Changes: 
 emacsen-common (1.4.23) unstable; urgency=low
 .
   * Remove vestigal dependency on bsdmainutils.  Thanks to Sven Joachim
     <svenjoac@gmx.de> for the report. (Closes: #480894)
 .
   * Require add-on packages to create .el symlinks alongside .elc files.
     Update debian-emacs-policy to require add-on packages to install a .el
     symlink alongside each compiled .elc file.  Thanks to "Karl
     M. Hegbloom" <karlheg@microsharp.com> for the original
     report. (Closes: #122444)
Checksums-Sha1: 
 5676656fdf52b35d247b79498365d399045f3b62 763 emacsen-common_1.4.23.dsc
 36633e9d377a77d1e4147fc3ff1048ccd5a38859 35209 emacsen-common_1.4.23.tar.gz
 9839148724c10ad1316d9dd5b038cd21587b3c0c 19056 emacsen-common_1.4.23_all.deb
Checksums-Sha256: 
 b605de24d72cb48d06ba9cca63064ad7a3d57d9d4a5da5916aa0bc3f3bc736be 763 emacsen-common_1.4.23.dsc
 5d0b77f95feb55c991ef685a8640e63ca6c2a94c477029200a1008bc4fd9a5e2 35209 emacsen-common_1.4.23.tar.gz
 1eab9181836ccff8f094ef5f8fee57314ebe671bf26dd86406f3ff93dd14d775 19056 emacsen-common_1.4.23_all.deb
Files: 
 1fc224c1846420544c02c9133144a396 763 editors optional emacsen-common_1.4.23.dsc
 b6166007890463298fe140d0c6098043 35209 editors optional emacsen-common_1.4.23.tar.gz
 5e66a02a51dafea7923bf22a735daa1b 19056 editors optional emacsen-common_1.4.23_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.11 (GNU/Linux)

iEYEARECAAYFAk825VoACgkQJcjTd4x+c6SoiwCgzu2VjgL33Z0JpL7+4UKUZfTo
IH8AoOAanVmJ9Ojv/+cY7F6kICKr2KGG
=Jv8+
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 21 Mar 2012 07:35:11 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 07:46:10 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.